SystemOrganization addCategory: #'Pier-Seaside-Core'!
SystemOrganization addCategory: #'Pier-Seaside-Model'!
SystemOrganization addCategory: #'Pier-Seaside-View'!
SystemOrganization addCategory: #'Pier-Seaside-Widgets'!
SystemOrganization addCategory: #'Pier-Seaside-Magritte'!
SystemOrganization addCategory: #'Pier-Seaside-Renderer'!

!ByteArray methodsFor: '*pier-seaside' stamp: 'lr 4/17/2005 11:57'!
asMIMEDocument
	^ MIMEDocument content: self.! !

!WAPresenter methodsFor: '*pier-seaside-accessing' stamp: 'lr 1/5/2006 10:26'!
context
	^ PRCurrentContext value.! !

!WAPresenter methodsFor: '*pier-seaside-accessing' stamp: 'lr 1/5/2006 10:27'!
context: aContext
	PRCurrentContext value: aContext.! !

!WAPresenter methodsFor: '*pier-seaside-events' stamp: 'lr 10/25/2005 23:11'!
onChangeContext: aContext
	"Inform components about a new context that will be used from now on."! !

!PRCommand methodsFor: '*pier-seaside-converting' stamp: 'lr 4/17/2005 11:57'!
asComponent
	^ super asComponent
		addValidatedForm;
		yourself.! !

PRCommand subclass: #PRSettingsComponentCommand
	instanceVariableNames: 'settings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Model'!

!PRSettingsComponentCommand class methodsFor: 'testing' stamp: 'lr 4/18/2005 09:08'!
isAbstract
	^ false! !

!PRSettingsComponentCommand class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:48'!
label
	^ 'Settings'! !

!PRSettingsComponentCommand class methodsFor: 'accessing-configuration' stamp: 'lr 12/21/2005 23:07'!
structureClass
	^ PRComponent! !

!PRSettingsComponentCommand methodsFor: 'accessing-delegated' stamp: 'lr 4/18/2005 09:12'!
description
	^ self structure componentClass description.! !

!PRSettingsComponentCommand methodsFor: 'events' stamp: 'lr 10/21/2005 10:56'!
doAnswer
	super doAnswer.
	self context removeComponentAt: self structure.! !

!PRSettingsComponentCommand methodsFor: 'events' stamp: 'lr 4/18/2005 09:16'!
doExecute
	super doExecute.
	self structure settings: self settings.! !

!PRSettingsComponentCommand methodsFor: 'events' stamp: 'lr 4/18/2005 09:16'!
doInitialize
	super doInitialize.
	self settings: self structure settings.! !

!PRSettingsComponentCommand methodsFor: 'private' stamp: 'lr 9/21/2005 07:32'!
readUsing: aDescription
	^ self settings at: aDescription ifAbsent: [ aDescription default ].! !

!PRSettingsComponentCommand methodsFor: 'accessing' stamp: 'lr 1/19/2006 08:43'!
settings
	^ settings ifNil: [ settings := Dictionary new ].! !

!PRSettingsComponentCommand methodsFor: 'accessing' stamp: 'lr 4/18/2005 09:15'!
settings: aDictionary
	settings := aDictionary! !

!PRSettingsComponentCommand methodsFor: 'private' stamp: 'lr 9/21/2005 07:33'!
write: anObject using: aDescription
	self settings at: aDescription put: anObject.! !

!PRViewCommand methodsFor: '*pier-seaside-converting' stamp: 'lr 10/21/2005 13:26'!
asComponent
	^ self viewComponent.! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 12/1/2005 20:14'!
name
	^ self viewComponent name.! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 1/5/2006 10:23'!
viewComponent
	^ self propertyAt: #viewComponent ifAbsentPut: [ self viewComponentClass on: self context ].! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 15:24'!
viewComponentClass
	^ self propertyAt: #viewComponentClass ifAbsentPut: [ self context structure viewComponentClass ].! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 15:23'!
viewComponentClass: aClass
	self propertyAt: #viewComponentClass put: aClass.! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 13:25'!
viewComponent: aViewComponent
	self propertyAt: #viewComponent put: aViewComponent.! !

!WAUrl methodsFor: '*pier-seaside-mapping' stamp: 'lr 2/13/2006 15:39'!
adaptToContext: aContext
	path := aContext session application baseUrl path copy.
	aContext structure parents allButFirst
		do: [ :each | self path add: each name ].
	aContext command isView
		ifTrue: [ self addParameter: 'view' value: aContext command viewComponentClass name asString ].
	self addParameter: 'command' value: aContext command class name asString.! !

!WAHtmlRenderer methodsFor: '*pier-seaside' stamp: 'lr 11/17/2005 15:36'!
anchorToStructure: aStructure command: aCommand do: aBlock
	self
		anchorWithAction: [
			PRCurrentContext value: (PRCurrentContext value
				structure: aStructure command: aCommand) ]
		do: aBlock.! !

!WAHtmlRenderer methodsFor: '*pier-seaside' stamp: 'lr 4/17/2005 11:57'!
textPasswordOn: aSymbol of: anObject
	self passwordInputWithCallback: (self callbackForSelector: aSymbol of: anObject).! !

WASystemConfiguration subclass: #PRPierConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRPierConfiguration methodsFor: 'attributes' stamp: 'lr 11/17/2005 16:06'!
attributeKernel
	^ (WAListAttribute key: #kernel group: #pier) 
		options: PRKernel instances;
		yourself.! !

!PRPierConfiguration methodsFor: 'attributes' stamp: 'lr 11/24/2005 16:46'!
attributeScriptaculous
	^ WABooleanAttribute key: #scriptaculous group: #pier.! !

!PRPierConfiguration methodsFor: 'accessing' stamp: 'lr 11/24/2005 16:52'!
attributes
	^ (self class selectors 
		select: [ :each | each ~= #attributes
			and: [ each beginsWith: #attribute ] ])
		collect: [ :each | self perform: each ].! !

!PRPierConfiguration methodsFor: 'accessing' stamp: 'lr 11/24/2005 16:47'!
scriptaculous
	^ true! !

PRStructure subclass: #PRComponent
	instanceVariableNames: 'componentClass settings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Model'!

!PRComponent class methodsFor: 'accessing-description' stamp: 'lr 2/13/2006 17:45'!
descriptionComponentClass
	^ (MASingleOptionDescription selector: #componentClass label: 'Component Class' priority: 200)
		propertyAt: #editable put: true;
		options: (MADynamicObject on: [
			Array streamContents: [ :stream |
				PRWidget allSubclassesDo: [ :each |
					each isAbstract
						ifFalse: [ stream nextPut: each ] ].
				WAComponent allSubclassesDo: [ :each |
					each canBeRoot
						ifTrue: [ stream nextPut: each ] ] ] ]);
		reference: MAClassDescription new;
		beRequired;
		beSorted;
		yourself.! !

!PRComponent class methodsFor: 'accessing-resources' stamp: 'lr 11/20/2005 20:10'!
icon
	"PRCompatibility compileFileNamed: 'icons/component.png' into: PRComponent class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 3 90 73 68 65 84 120 218 98 252 255 255 63 3 12 28 63 126 13 193 193 2 206 157 187 193 32 36 196 207 184 108 217 122 32 45 196 176 112 97 19 3 64 0 177 160 43 50 53 85 103 248 251 247 31 195 159 63 127 25 126 253 250 13 164 255 49 124 249 242 157 129 137 137 9 40 171 1 50 228 255 166 77 147 25 227 226 106 193 234 1 2 136 5 155 77 95 255 49 50 60 124 205 198 192 253 159 145 65 144 231 23 3 51 51 19 3 204 161 166 166 90 12 211 166 173 7 58 28 40 9 4 0 1 132 98 192 31 22 86 134 71 63 152 24 190 127 103 100 120 253 138 129 225 206 51 118 134 183 239 152 25 116 181 126 49 72 137 255 6 123 1 6 44 45 141 65 70 50 2 4 16 138 1 111 190 179 50 172 221 199 200 160 206 201 192 192 254 137 129 225 232 229 159 12 251 174 220 98 136 255 241 147 33 210 89 148 193 217 217 132 225 235 215 31 12 159 63 127 103 184 122 245 46 88 15 64 0 161 24 192 199 240 155 225 214 77 6 134 71 191 126 49 220 127 241 151 225 194 237 135 12 12 239 207 50 252 254 204 199 240 245 11 7 195 143 159 255 192 97 194 196 196 8 215 3 16 64 48 3 248 25 62 190 140 19 248 243 155 225 219 139 175 12 76 127 191 48 188 122 249 17 24 24 215 25 24 62 223 100 248 242 70 134 225 205 91 97 134 127 255 152 25 184 56 185 25 88 88 89 225 6 0 4 16 19 195 236 57 89 192 96 222 201 240 242 221 36 169 159 239 24 196 63 63 97 120 126 227 35 195 175 103 183 25 24 94 92 99 96 124 123 133 129 145 225 9 195 155 215 111 24 254 255 251 203 192 202 202 204 192 206 142 48 0 32 128 88 24 182 111 155 194 112 233 34 35 131 150 22 3 211 179 135 12 130 103 142 48 24 187 37 48 124 59 245 159 129 145 243 40 131 182 217 109 6 54 133 143 64 219 13 129 49 241 23 24 108 12 224 88 129 1 128 0 98 97 120 251 246 51 195 253 123 124 127 246 237 99 56 112 253 22 195 67 215 63 12 234 245 127 24 66 30 104 50 252 253 255 139 225 233 103 14 134 157 123 174 50 232 241 49 128 211 2 19 35 35 3 11 11 51 220 0 128 0 98 249 247 249 51 247 223 159 191 24 190 126 254 204 240 246 255 31 134 255 192 24 216 241 234 36 131 16 211 5 6 134 7 130 12 87 182 189 7 70 15 208 70 185 255 12 255 254 255 3 186 224 63 208 37 255 224 6 0 4 16 203 167 183 111 55 254 249 254 221 251 215 159 63 236 55 129 238 123 247 237 63 3 11 48 13 188 126 243 147 225 237 169 23 12 63 30 49 48 176 253 101 101 248 7 76 157 127 129 129 12 74 250 72 169 159 1 32 128 152 26 254 253 79 62 240 229 107 236 163 207 95 206 124 214 214 99 208 240 12 100 248 244 152 153 225 59 208 16 134 47 12 12 255 63 48 48 112 124 226 101 248 243 247 47 48 10 255 0 147 249 95 6 228 252 3 16 64 44 91 152 153 127 110 17 19 59 206 253 239 95 113 66 98 198 65 113 49 126 6 241 183 138 12 39 190 30 98 184 253 230 30 131 149 152 14 131 149 166 45 216 217 160 60 242 239 31 200 249 8 3 0 2 8 148 14 128 65 203 240 227 43 19 211 59 94 62 126 6 30 110 94 6 99 38 11 6 67 78 51 134 95 118 192 204 244 251 55 56 99 49 51 51 131 67 31 146 169 16 0 32 128 96 6 124 3 226 183 79 159 125 96 120 240 240 37 208 175 127 129 182 253 1 59 249 15 208 223 160 192 99 101 5 102 46 110 30 6 94 222 215 12 28 28 92 192 152 128 164 65 128 0 3 0 119 56 99 163 229 209 92 150 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!PRComponent class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRComponent methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:19'!
accept: aVisitor
	aVisitor visitComponent: self.! !

!PRComponent methodsFor: 'actions' stamp: 'lr 10/25/2005 23:45'!
component
	^ self componentClass ifNotNilDo: [ :class | 
		class new in: [ :component |
			self settings keysAndValuesDo: [ :description :value |
				component write: value using: description ].
			component ] ].! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 8/13/2005 12:50'!
componentClass
	^ componentClass ifNil: [ WAComponent ].! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 2/13/2006 17:47'!
componentClass: aComponentClass
	componentClass := aComponentClass.
	self reset; flush.! !

!PRComponent methodsFor: 'actions' stamp: 'lr 2/13/2006 17:48'!
flush
	PRCurrentContext value
		ifNotNilDo: [ :context | context removeComponentAt: self ].! !

!PRComponent methodsFor: 'initialize-release' stamp: 'lr 4/17/2005 11:57'!
initialize
	super initialize.
	self reset.! !

!PRComponent methodsFor: 'actions' stamp: 'lr 4/17/2005 11:57'!
reset
	self settings: Dictionary new.! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
settings
	^ settings! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
settings: aDictionary 
	settings := aDictionary! !

!PRStructure methodsFor: '*pier-seaside-accessing' stamp: 'lr 1/11/2006 22:01'!
environment
	"Answer the (inherited) environment of the receiver, if none is available a default one is created."

	^ self childrenDecoration
		at: self environmentSelector
		ifAbsent: [
			self isRoot
				ifFalse: [ self parent environment ]
				ifTrue: [ self childrenDecoration add: self environmentStructure ] ].! !

!PRStructure methodsFor: '*pier-seaside-configuration' stamp: 'lr 2/13/2006 15:43'!
environmentSelector
	^ 'environment'! !

!PRStructure methodsFor: '*pier-seaside-configuration' stamp: 'lr 2/13/2006 15:43'!
environmentStructure
	^ (PRPage named: 'environment')
		addDecoration: PRHider new;
		addChild: ((PRComponent named: 'header') 
			componentClass: PRHeaderWidget;
			yourself);
		addChild: ((PRComponent named: 'views')
			componentClass: PRViewsWidget;
			yourself);
		addChild: ((PRComponent named: 'commands')
			componentClass: PRCommandsWidget;
			yourself);
		addChild: ((PRComponent named: 'tree')
			componentClass: PRTreeWidget;
			yourself);
		addChild: ((PRComponent named: 'contents')
			componentClass: PRContentsWidget;
			yourself);
		contents: '+header+
<table class="body"><tr><td class="boxes">+views+<br />+commands+<br />+tree+</td><td class="spacer"></td><td class="contents">+contents+</td></tr></table>
<div align="right">Pier &mdash; Empowered by Seaside</div>';
		yourself.! !

!PRStructure methodsFor: '*pier-seaside-testing' stamp: 'lr 11/14/2005 09:17'!
isValidView: aComponentClass in: aContext
	"Answer true if aComponentClass is a valid command in aContext."
	
	^ true! !

!PRStructure methodsFor: '*pier-seaside-configuration' stamp: 'lr 11/17/2005 16:09'!
viewComponentClass
	"Return the default view component class of the reciever."

	^ PRDefaultView.! !

!WACounter class methodsFor: '*pier-seaside-accessing-description' stamp: 'lr 1/18/2006 15:09'!
descriptionCount
	^ (MANumberDescription selector: #count label: 'Count' priority: 200)
		beRequired;
		beInteger;
		yourself.! !

!WACounter methodsFor: '*pier-seaside-accessing' stamp: 'lr 4/17/2005 11:57'!
count: anInteger
	count := anInteger! !

MAComponent subclass: #PRPierFrame
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRPierFrame class methodsFor: 'testing' stamp: 'lr 1/25/2006 16:44'!
canBeRoot
	^ true! !

!PRPierFrame class methodsFor: 'examples' stamp: 'lr 1/11/2006 22:39'!
exampleBasic
	"Pier can be easily used as a component within any Seaside application, this is just an example of a dumb wiki. To see this example browse to /seaside/examplebrowser and select the receiver class."
	
	^ self on: (PRContext kernel: (PRKernel new
		name: 'Pier';
		root: (PRPage new
			title: 'Pier Example';
			contents: 'Pier can be easily used as a component within any Seaside application (maybe you should adapt the style-sheets), this is just an example of a dumb and non-persistent wiki.';
			yourself))).! !

!PRPierFrame class methodsFor: 'examples' stamp: 'lr 1/11/2006 22:41'!
exampleDocs
	"Create a (static) Pier instance from all the comments in the source code of pier, a sort of poor mans documentation. It might take a while to get all the classes traversed and to parse the source."

	^ self on: (PRContext kernel: (PRKernel new
		name: 'Pier Docs';
		root: (self pageForClass: PRObject);
		yourself)).! !

!PRPierFrame class methodsFor: 'class initialization' stamp: 'lr 1/11/2006 21:51'!
initialize
	| kernel |
	kernel := nil.
	(PRCompatibility confirm: 'Would you like to create a Seaside application for Pier?') ifTrue: [
		(PRKernel instances isEmpty or: [ PRCompatibility confirm: 'Would you like to create a new Pier kernel?' ]) ifTrue: [ 
			(PRCompatibility request: 'Please enter the name of your Pier kernel:' default: PRDistribution productName)
				ifNotNilDo: [ :value | kernel := PRKernel named: value ] ].
		(PRKernel instances notEmpty and: [ kernel isNil ]) ifTrue: [
			kernel := PRCompatibility choose: 'Select the Pier kernel you would like to use:' from: PRKernel instances ].
		kernel notNil ifTrue: [
			(PRCompatibility request: 'Enter the entry point:' default: 'pier') ifNotNilDo: [ :path |
				PRCompatibility inform: 'Your Pier-Application is running on: ' , (self registerAsApplication: path kernel: kernel) baseUrl asString ] ] ].! !

!PRPierFrame class methodsFor: 'testing' stamp: 'lr 1/5/2006 09:39'!
isAbstract
	^ false! !

!PRPierFrame class methodsFor: 'instance creation' stamp: 'lr 1/5/2006 10:18'!
on: aContext
	"This contructor creates a new SmallWiki frame that can be used within any Seaside application. It doesn't require a special session class, since all the required state is hold in the context of the wiki itself."

	^ self new
		context: aContext;
		yourself.! !

!PRPierFrame class methodsFor: 'examples' stamp: 'lr 1/11/2006 22:38'!
pageForClass: aClass
	| page |
	page := PRPage new
		title: aClass name;
		contents: (String streamContents: [ :stream |
			stream nextPutAll: '!!Class definition'; cr.
			aClass definition
				linesDo: [ :each | stream nextPut: $=; nextPutAll: each; cr ].
			aClass hasComment ifTrue: [
				stream nextPutAll: '!!Class comment'; cr.
				stream nextPutAll: aClass comment; cr ] ]);
		yourself.
	aClass subclassesDo: [ :each | page addChild: (self pageForClass: each) ].
	^ page.! !

!PRPierFrame class methodsFor: 'registration' stamp: 'lr 1/5/2006 09:39'!
registerAsApplication: aString kernel: aKernel	
	| application |
	application := self registerAsApplication: aString.
	application configuration addAncestor: PRPierConfiguration new.
	^ application
		preferenceAt: #mainClass put: PRPierMain;
		preferenceAt: #kernel put: aKernel;
		yourself.! !

!PRPierFrame methodsFor: 'accessing-dynamic' stamp: 'lr 1/5/2006 09:39'!
children
	^ self context components.! !

!PRPierFrame methodsFor: 'processing' stamp: 'lr 1/5/2006 09:39'!
childrenDo: aStream
	self withContextDo: [ super childrenDo: aStream ].! !

!PRPierFrame methodsFor: 'accessing' stamp: 'lr 1/5/2006 09:39'!
context
	^ context! !

!PRPierFrame methodsFor: 'accessing' stamp: 'lr 1/5/2006 10:19'!
context: aContext
	context := aContext.
	self update.! !

!PRPierFrame methodsFor: 'accessing-dynamic' stamp: 'lr 1/16/2006 11:46'!
environment
	^ self context structure environment.! !

!PRPierFrame methodsFor: 'rendering' stamp: 'lr 1/5/2006 09:39'!
renderContentOn: html
	html div 
		class: 'frame';
		with: [
			self context renderer
				start: self environment
				in: self on: html ].! !

!PRPierFrame methodsFor: 'processing' stamp: 'lr 1/5/2006 09:39'!
renderWithContext: aContext
	self withContextDo: [ super renderWithContext: aContext ].! !

!PRPierFrame methodsFor: 'processing' stamp: 'lr 1/5/2006 10:20'!
update
	self visiblePresentersDo: [ :each | each onChangeContext: self context ].! !

!PRPierFrame methodsFor: 'updating' stamp: 'lr 1/9/2006 10:28'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot docType: '<?xml version="1.0" encoding="UTF-8"?><!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'.
	aHtmlRoot htmlAttributes at: 'xmlns' put: 'http://www.w3.org/1999/xhtml'.
	aHtmlRoot addHeadElement: ((WAHtmlElement named: 'meta')
		attributeAt: 'name' put: 'generator';
		attributeAt: 'content' put: PRDistribution versionString;
		yourself).! !

!PRPierFrame methodsFor: 'updating' stamp: 'lr 1/5/2006 09:39'!
updateUrl: anUrl
	super updateUrl: anUrl.
	anUrl adaptToContext: self context.! !

!PRPierFrame methodsFor: 'private' stamp: 'lr 1/5/2006 09:39'!
withContextDo: aBlock
	^ PRCurrentContext use: self during: aBlock.! !

MAComponent subclass: #PRViewComponent
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

PRViewComponent subclass: #PRDefaultView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRDefaultView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:27'!
isAbstract
	^ false! !

!PRDefaultView class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'View'! !

!PRDefaultView methodsFor: 'accessing' stamp: 'lr 1/18/2006 15:20'!
name
	^ self context structure title.! !

!PRDefaultView methodsFor: 'rendering' stamp: 'lr 1/27/2006 10:16'!
renderContentOn: html
	"This check is required to make it possible to display /Environemnt/Contents and avoid uncotrolled recursion. We don't remeber the recursion within an i-var, because this doesn't work together with continuations that might escape from this context. This implementation is using the exception mechanism and is ways faster than searching the stack manually."

	PRRecursionBlocker
		do: [ self context renderer continue: self context structure in: self on: html ]
		else: [ html render: 'Unable to fully display recursive composition.' ].! !

PRViewComponent subclass: #PRHistoryView
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

PRHistoryView subclass: #PRChangesView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRChangesView class methodsFor: 'testing' stamp: 'lr 1/19/2006 08:53'!
isAbstract
	^ false! !

!PRChangesView class methodsFor: 'accessing' stamp: 'lr 1/19/2006 09:18'!
label
	^ 'Changes'! !

!PRChangesView methodsFor: 'private' stamp: 'lr 1/19/2006 10:33'!
buildList
	^ Array streamContents: [ :stream |
		self context kernel persistency
			reverseDo: [ :each | 
				each command isEdit
					ifTrue: [ stream nextPut: each ] ] 
			for: self context structure ].! !

!PRChangesView methodsFor: 'private' stamp: 'lr 1/19/2006 09:25'!
buildReport
	^ super buildReport
		addColumn: (MACommandColumn new
			addCommand: [ :value | self apply: value ] text: 'restore';
			yourself);
		yourself.! !

!PRHistoryView methodsFor: 'actions' stamp: 'lr 1/23/2006 09:23'!
apply: aCommand
	aCommand execute.! !

!PRHistoryView methodsFor: 'private' stamp: 'lr 1/19/2006 10:33'!
buildDescription
	^ PRContext description.! !

!PRHistoryView methodsFor: 'private' stamp: 'lr 2/13/2006 18:14'!
buildList
	self subclassResponsibility.! !

!PRHistoryView methodsFor: 'private' stamp: 'lr 1/23/2006 09:24'!
buildReport
	^ (MAReport rows: self buildList description: self buildDescription)
		sortEnabled: false;
		batchSize: 20;
		yourself.! !

!PRHistoryView methodsFor: 'accessing' stamp: 'lr 1/19/2006 09:03'!
children
	^ Array with: self report.! !

!PRHistoryView methodsFor: 'actions' stamp: 'lr 1/19/2006 09:23'!
open: aCommand
	self context: (self context command: aCommand).! !

!PRHistoryView methodsFor: 'rendering' stamp: 'lr 1/19/2006 09:04'!
renderContentOn: html
	html render: self report.! !

!PRHistoryView methodsFor: 'accessing' stamp: 'lr 1/19/2006 09:13'!
report
	^ report ifNil: [ report := self buildReport ].! !

PRHistoryView subclass: #PRLogView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRLogView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:27'!
isAbstract
	^ false! !

!PRLogView class methodsFor: 'accessing' stamp: 'lr 1/19/2006 08:52'!
label
	^ 'Log'! !

!PRLogView methodsFor: 'private' stamp: 'lr 1/23/2006 09:25'!
buildList
	^ Array streamContents: [ :stream |
		self context kernel persistency
			reverseDo: [ :each | stream nextPut: each ]
			for: self context structure ].! !

PRViewComponent subclass: #PRRawView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

PRRawView subclass: #PRDownloadView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRDownloadView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:28'!
isAbstract
	^ false! !

!PRDownloadView class methodsFor: 'testing' stamp: 'lr 11/17/2005 15:44'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isKindOf: PRFile ].! !

!PRDownloadView class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Download'! !

!PRDownloadView methodsFor: 'rendering' stamp: 'lr 10/23/2005 19:28'!
renderContentOn: aRequest
	self context structure file in: [ :file |
		aRequest 
			contentType: file mimetype;
			attachmentWithFileName: file filename;
			nextPutAll: file contents ].! !

!PRRawView methodsFor: 'rendering' stamp: 'lr 10/21/2005 17:57'!
renderWithContext: aRenderingContext
	| response |
	self renderContentOn: (response := WAResponse new).
	self session returnResponse: response.! !

PRRawView subclass: #PRWikiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRWikiView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:28'!
isAbstract
	^ false! !

!PRWikiView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:42'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure hasDocument ].! !

!PRWikiView class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Wiki'! !

!PRWikiView methodsFor: 'rendering' stamp: 'lr 12/22/2005 14:28'!
renderContentOn: aRequest
	aRequest contentType: 'text/wiki'.
	PRDocumentWriter 
		write: self context structure document 
		to: aRequest stream.! !

PRViewComponent subclass: #PRReportView
	instanceVariableNames: 'report description structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRReportView class methodsFor: 'testing' stamp: 'lr 11/24/2005 17:34'!
isAbstract
	^ false! !

!PRReportView class methodsFor: 'accessing' stamp: 'lr 11/24/2005 17:34'!
label
	^ 'Report'! !

!PRReportView methodsFor: 'private' stamp: 'lr 1/14/2006 17:40'!
buildDescription
	self structures isEmpty
		ifTrue: [ ^ MAContainer new ].
	^ (self structures 
		inject: self structures first description
		into: [ :container :structure | container intersection: structure description ])
			select: [ :each | each isVisible ].! !

!PRReportView methodsFor: 'private' stamp: 'lr 11/24/2005 18:40'!
buildReport
	^ MAReport rows: self structures description: self description.! !

!PRReportView methodsFor: 'private' stamp: 'lr 1/14/2006 17:11'!
buildStructures
	^ self context structure enumerator
		all; 
		contents. ! !

!PRReportView methodsFor: 'accessing' stamp: 'lr 11/24/2005 17:54'!
children
	^ Array with: self report.! !

!PRReportView methodsFor: 'accessing' stamp: 'lr 1/14/2006 17:38'!
description
	^ description ifNil: [ description := self buildDescription ].! !

!PRReportView methodsFor: 'rendering' stamp: 'lr 1/14/2006 17:39'!
renderContentOn: html
	"self renderSelectorsOn: html."
	self renderReportOn: html.! !

!PRReportView methodsFor: 'rendering' stamp: 'lr 1/14/2006 17:29'!
renderReportOn: html
	html div
		id: (self ajaxId: #report);
		with: self report.! !

!PRReportView methodsFor: 'rendering' stamp: 'lr 1/14/2006 17:33'!
renderSelectorsOn: html
	html form: [
		self selectors do: [ :each |
			html checkbox
				onChange: (html ajax
					id: (self ajaxId: #report);
					addParameter: (SUFormElement new 
						id: (self ajaxId: each); 
						serialize);
					on: #renderReportOn: of: self);
				on: #recursive of: self.
			html label 
				for: (self ajaxId: each);
				do: each ] ].! !

!PRReportView methodsFor: 'accessing' stamp: 'lr 1/14/2006 17:38'!
report
	^ report ifNil: [ report := self buildReport ].! !

!PRReportView methodsFor: 'accessing' stamp: 'lr 1/14/2006 17:38'!
structures
	^ structures ifNil: [ structures := self buildStructures ].! !

PRViewComponent subclass: #PRSearchView
	instanceVariableNames: 'conditions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRSearchView class methodsFor: 'testing' stamp: 'lr 2/11/2006 11:09'!
isAbstract
	^ false! !

!PRSearchView class methodsFor: 'accessing' stamp: 'lr 2/11/2006 11:09'!
label
	^ 'Search'! !

!PRSearchView methodsFor: 'actions' stamp: 'lr 2/11/2006 17:14'!
addCondition
	^ self conditions addLast: 10000 atRandom asString.! !

!PRSearchView methodsFor: 'actions' stamp: 'lr 2/11/2006 11:34'!
add: anIndex
	self conditions add: 100 atRandom asString afterIndex: anIndex.! !

!PRSearchView methodsFor: 'accessing' stamp: 'lr 2/11/2006 11:32'!
conditions
	^ conditions ifNil: [ conditions := OrderedCollection with: 'foo' with: 'bar' with: 'zork' ]! !

!PRSearchView methodsFor: 'actions' stamp: 'lr 2/11/2006 15:39'!
remove: anIndex
	self conditions removeIndex: anIndex.! !

!PRSearchView methodsFor: 'rendering-buttons' stamp: 'lr 2/12/2006 00:12'!
renderAdd: aCondition index: anInteger on: html
	html submitButton
		onClick: (html ajax 
			insertBottom;
			id: (self ajaxId: 'conditions');
			callback: [ :renderer | 
				self
					renderCondition: self addCondition 
					index: self conditions size 
					on: renderer ];
			returnFalse);
		tooltip: 'Add search criteria';
		callback: [ self addCondition ];
		value: '+'.! !

!PRSearchView methodsFor: 'rendering-conditions' stamp: 'lr 2/11/2006 17:19'!
renderConditionsOn: html
	html div
		id: (self ajaxId: 'conditions');
		with: [
			self conditions withIndexDo: [ :each :index |
				self renderCondition: each index: index on: html ] ].! !

!PRSearchView methodsFor: 'rendering-conditions' stamp: 'lr 2/12/2006 00:25'!
renderCondition: aCondition index: anInteger on: html
	html div
		id: (self ajaxId: 'condition' , anInteger asString);
		style: (anInteger odd ifTrue: [ 'padding: 3px; background-color: #eeeeff' ] ifFalse: [ 'padding: 3px' ]);
		with: [
			html div
				style: 'float: left';
				with: [ self renderCondition: aCondition on: html ].
			html div
				style: 'float: right';
				with: [
					self renderAdd: aCondition index: anInteger on: html.
					self renderRemove: aCondition index: anInteger on: html ].
			html div
				style: 'clear: both';
				with: nil ].! !

!PRSearchView methodsFor: 'rendering-conditions' stamp: 'lr 2/12/2006 00:23'!
renderCondition: aCondition on: html
	html select
		list: #( 'Kind' 'Size' 'Page' ).
	html space.
	html select
		list: #( 'begins with' 'ends with' 'contains' ).
	html space.
	html textInput .! !

!PRSearchView methodsFor: 'rendering' stamp: 'lr 2/12/2006 00:08'!
renderContentOn: html
	html form: [ self renderConditionsOn: html ].! !

!PRSearchView methodsFor: 'rendering-buttons' stamp: 'lr 2/12/2006 00:18'!
renderRemove: aCondition index: anInteger on: html
	html submitButton
		disabled: self conditions size <= 1;
		onClick: (html ajax
			id: (self ajaxId: 'conditions');
			callback: [ :renderer | 
				self remove: anInteger.
				self renderConditionsOn: renderer ];
			returnFalse);
		callback: [ self remove: anInteger ];
		tooltip: 'Remove search criteria';
		value: '-'.! !

!PRViewComponent class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:15'!
isValidIn: aContext
	"Verify that a view as a meaning for the context aContext. Override this message, to add new tests, but do not forget to call this super implementation."
	
	^ aContext structure isValidView: self in: aContext.! !

!PRViewComponent class methodsFor: 'instance-creation' stamp: 'lr 1/5/2006 10:23'!
on: aContext
	^ self new
		setContext: aContext;
		yourself.! !

!PRViewComponent methodsFor: 'accessing' stamp: 'lr 1/5/2006 10:23'!
context
	^ context! !

!PRViewComponent methodsFor: 'accessing' stamp: 'lr 12/1/2005 20:16'!
name
	^ self class label.! !

!PRViewComponent methodsFor: 'rendering' stamp: 'lr 10/21/2005 13:16'!
renderContentOn: html
	html strong: self context.! !

!PRViewComponent methodsFor: 'initialization' stamp: 'lr 1/5/2006 10:24'!
setContext: aContext
	context := aContext! !

MAComponent subclass: #PRWidget
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

PRWidget subclass: #PRBoxWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRBoxWidget class methodsFor: 'accessing-defaults' stamp: 'lr 2/19/2006 14:52'!
defaultCssClass
	^ String new! !

!PRBoxWidget class methodsFor: 'accessing-defaults' stamp: 'lr 2/19/2006 14:52'!
defaultCssName
	^ String new! !

!PRBoxWidget class methodsFor: 'accessing-defaults' stamp: 'lr 2/19/2006 14:52'!
defaultTitle
	^ self label! !

!PRBoxWidget class methodsFor: 'accessing-description' stamp: 'lr 2/19/2006 14:52'!
descriptionCssClass
	^ MAStringDescription selector: #cssClass label: 'CSS Class' priority: 120 default: self defaultCssClass.! !

!PRBoxWidget class methodsFor: 'accessing-description' stamp: 'lr 2/19/2006 14:52'!
descriptionCssName
	^ MAStringDescription selector: #cssName label: 'CSS Name' priority: 110 default: self defaultCssName.! !

!PRBoxWidget class methodsFor: 'accessing-description' stamp: 'lr 2/19/2006 14:53'!
descriptionTitle
	^ MAStringDescription selector: #title label: 'Title' priority: 100 default: self defaultTitle.! !

!PRBoxWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:47'!
cssClass
	^ self propertyAt: #cssClass ifAbsent: [ self class defaultCssClass ].! !

!PRBoxWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:47'!
cssClass: aString
	self propertyAt: #cssClass put: aString.! !

!PRBoxWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:48'!
cssName
	^ self propertyAt: #cssName ifAbsent: [ self class defaultCssName ].! !

!PRBoxWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:48'!
cssName: aString
	self propertyAt: #cssName put: aString.! !

!PRBoxWidget methodsFor: 'testing' stamp: 'lr 2/19/2006 14:51'!
isVisible
	"Answer true if the receiver is visible. Some subclasses might want to override this message to hide the reciever in certain cases."
	
	^ true! !

!PRBoxWidget methodsFor: 'rendering' stamp: 'lr 2/19/2006 14:50'!
renderContentOn: html
	self isVisible
		ifFalse: [ ^ self ].
	html div
		id: self cssName;
		class: self cssClass;
		with: [
			self renderWidgetTitleOn: html.
			super renderContentOn: html ].! !

!PRBoxWidget methodsFor: 'rendering' stamp: 'lr 2/19/2006 14:51'!
renderWidgetTitleOn: html
	self title isEmptyOrNil
		ifFalse: [ html heading: (self expand: self title) ].! !

!PRBoxWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:48'!
title
	^ self propertyAt: #title ifAbsent: [ self class defaultTitle ].! !

!PRBoxWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:48'!
title: aString
	self propertyAt: #title put: aString.! !

PRBoxWidget subclass: #PRContentsWidget
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRContentsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'contents'! !

!PRContentsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 2/13/2006 17:33'!
defaultTitle
	^ '%c'! !

!PRContentsWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRContentsWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Contents'! !

!PRContentsWidget methodsFor: 'private' stamp: 'lr 10/26/2005 00:05'!
buildComponent
	^ self context command asComponent
		onAnswer: [ :value | self onAnswerComponent: value ];
		yourself.! !

!PRContentsWidget methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
children
	^ Array with: self component.! !

!PRContentsWidget methodsFor: 'accessing' stamp: 'lr 10/26/2005 00:04'!
component
	^ component ifNil: [ component := self buildComponent ].! !

!PRContentsWidget methodsFor: 'accessing' stamp: 'lr 10/21/2005 13:30'!
component: aComponent
	component := aComponent! !

!PRContentsWidget methodsFor: 'initialization' stamp: 'lr 9/30/2005 20:16'!
initialize
	super initialize.
	self session registerObjectForBacktracking: self.! !

!PRContentsWidget methodsFor: 'events' stamp: 'lr 12/5/2005 16:51'!
onAnswerComponent: aCommand
	self context: (aCommand notNil
		ifTrue: [ aCommand execute; answer ]
		ifFalse: [ self context structure: self context structure ]).! !

!PRContentsWidget methodsFor: 'events' stamp: 'lr 12/20/2005 12:14'!
onChangeContext: aContext
	super onChangeContext: aContext.
	self context command isQuick
		ifTrue: [ self onAnswerComponent: self context command ]
		ifFalse: [ self component: self buildComponent ].! !

!PRContentsWidget methodsFor: 'rendering' stamp: 'lr 11/22/2005 23:35'!
renderWidgetOn: html
	html render: self component.! !

!PRContentsWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 17:44'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot title: self context structure title.! !

PRBoxWidget subclass: #PRListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

PRListWidget subclass: #PRCommandsWidget
	instanceVariableNames: 'commandClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRCommandsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 12/16/2005 12:00'!
defaultCommandClasses
	^ (Array withAll: PRCommand withAllConcreteClasses)
		sort: [ :a :b | a label caseInsensitiveLessOrEqual: b label ];
		yourself.! !

!PRCommandsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'box commands'! !

!PRCommandsWidget class methodsFor: 'accessing-description' stamp: 'lr 1/23/2006 09:38'!
descriptionCommandClasses
	^ (MAMultipleOptionDescription selector: #commandClasses label: 'Command Classes' priority: 200)
		options: (MADynamicObject on: [ self defaultCommandClasses ]);
		componentClass: MAListCompositonComponent;
		reference: MAClassDescription new;
		beOrdered;
		yourself.! !

!PRCommandsWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRCommandsWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Commands'! !

!PRCommandsWidget methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 11:57'!
commandClasses
	^ commandClasses ifNil: [ commandClasses := self class defaultCommandClasses ].! !

!PRCommandsWidget methodsFor: 'accessing-settings' stamp: 'lr 4/18/2005 09:23'!
commandClasses: aCollection
	commandClasses := aCollection! !

!PRCommandsWidget methodsFor: 'accessing' stamp: 'lr 12/21/2005 23:44'!
items
	| command |
	^ Array streamContents: [ :stream |
		self context commands in: [ :commands |
			self commandClasses do: [ :class |
				command := commands
					detect: [ :each | 
						each = class
							or: [ each inheritsFrom: class ] ]
					ifNone: [ nil ].
				command isNil 
					ifFalse: [ stream nextPut: command ] ] ] ].! !

!PRCommandsWidget methodsFor: 'rendering' stamp: 'lr 12/21/2005 00:07'!
renderItem: aClass on: html
	html anchor 
		goto: (self context 	
			structure: self context structure 
			command: aClass new);
		text: aClass shortLabel.! !

!PRCommandsWidget methodsFor: 'accessing' stamp: 'lr 9/30/2005 19:45'!
selected
	^ self context command class.! !

PRCommandsWidget subclass: #PRHeaderWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRHeaderWidget class methodsFor: 'accessing-defaults' stamp: 'lr 11/17/2005 15:52'!
defaultCommandClasses
	^ OrderedCollection
		with: PRViewCommand 
		with: PREditCommand.! !

!PRHeaderWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'header'! !

!PRHeaderWidget class methodsFor: 'accessing-defaults' stamp: 'lr 11/17/2005 20:23'!
defaultTitle
	^ '%k'! !

!PRHeaderWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 22:26'!
label
	^ 'Header'! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 18:08'!
renderLogoOn: html
	html tableData class: 'logo'.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 18:08'!
renderSpacerOn: html
	html tableData class: 'spacer'.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 19:48'!
renderTabsOn: html
	self renderItems: self items reversed on: html.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 10/21/2005 17:41'!
renderTitleOn: html
	html tableData class: 'start'.
	html tableData class: 'title'; with: (self expand: self title).
	html tableData class: 'tabs'; with: [ self renderTabsOn: html ].
	html tableData class: 'end'.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 18:10'!
renderWidgetOn: html
	html table
		class: 'header'; 
		with: [
			self renderLogoOn: html.
			self renderSpacerOn: html.
			self renderTitleOn: html ].! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 4/17/2005 11:58'!
renderWidgetTitleOn: html! !

!PRListWidget methodsFor: 'accessing' stamp: 'lr 11/1/2005 22:27'!
items
	self subclassResponsibility.! !

!PRListWidget methodsFor: 'rendering' stamp: 'lr 10/21/2005 16:43'!
renderItems: aCollection on: html
	html unorderedList with: [
		aCollection do: [ :each | 
			html listItem
				class: (self selected = each ifTrue: [ 'active' ]);
				with: [ self renderItem: each on: html ] ] ].! !

!PRListWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 19:41'!
renderItem: anObject on: html
	html render: anObject.! !

!PRListWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 19:39'!
renderWidgetOn: html
	self renderItems: self items on: html.! !

!PRListWidget methodsFor: 'accessing' stamp: 'lr 11/2/2005 21:55'!
selected
	self subclassResponsibility.! !

PRListWidget subclass: #PRStructuresWidget
	instanceVariableNames: 'filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

PRStructuresWidget subclass: #PRChildrenWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRChildrenWidget class methodsFor: 'accessing-defaults' stamp: 'lr 9/5/2005 20:02'!
defaultCssClass
	^ 'box children'! !

!PRChildrenWidget class methodsFor: 'testing' stamp: 'lr 9/5/2005 20:03'!
isAbstract
	^ false! !

!PRChildrenWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Children'! !

!PRChildrenWidget methodsFor: 'testing' stamp: 'lr 9/30/2005 19:42'!
isVisible
	^ self context structure hasChildren.! !

!PRChildrenWidget methodsFor: 'accessing' stamp: 'lr 1/14/2006 17:13'!
unfilteredItems
	^ self context structure enumerator contents.! !

PRStructuresWidget subclass: #PRNavigationWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRNavigationWidget class methodsFor: 'accessing-defaults' stamp: 'lr 2/19/2006 17:47'!
defaultCssClass
	^ 'box navigation'! !

!PRNavigationWidget class methodsFor: 'testing' stamp: 'lr 2/19/2006 17:48'!
isAbstract
	^ false! !

!PRNavigationWidget class methodsFor: 'accessing' stamp: 'lr 2/19/2006 17:48'!
label
	^ 'Navigation'! !

!PRNavigationWidget methodsFor: 'rendering' stamp: 'lr 2/19/2006 18:06'!
renderParents: aCollection on: html
	html unorderedList: [
		html listItem: [
			self renderItem: aCollection first on: html.
			(aCollection size = 1 or: [ aCollection size = 2 and: [ (aCollection last enumerator contents reject: [ :each | self isFiltered: each ]) isEmpty ] ])
				ifTrue: [ self renderItems: aCollection first enumerator contents on: html ]
				ifFalse: [ self renderParents: aCollection allButFirst on: html ] ] ].! !

!PRNavigationWidget methodsFor: 'rendering' stamp: 'lr 2/19/2006 17:58'!
renderWidgetOn: html
	self renderParents: self context structure parents on: html.! !

PRStructuresWidget subclass: #PRPathWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRPathWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'box path'! !

!PRPathWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRPathWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Path'! !

!PRPathWidget methodsFor: 'accessing' stamp: 'lr 12/16/2005 12:22'!
unfilteredItems
	^ self context structure parents.! !

PRStructuresWidget subclass: #PRReferencesWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRReferencesWidget class methodsFor: 'accessing-defaults' stamp: 'lr 11/1/2005 07:16'!
defaultCssClass
	^ 'box references'! !

!PRReferencesWidget class methodsFor: 'testing' stamp: 'lr 11/1/2005 07:17'!
isAbstract
	^ false! !

!PRReferencesWidget class methodsFor: 'accessing' stamp: 'lr 11/1/2005 07:18'!
label
	^ 'References'! !

!PRReferencesWidget methodsFor: 'testing' stamp: 'lr 11/1/2005 07:19'!
isVisible
	^ self items notEmpty.! !

!PRReferencesWidget methodsFor: 'accessing' stamp: 'lr 12/16/2005 12:22'!
unfilteredItems
	^ (PRReferences from: self context root to: self context structure)
		collect: [ :each | each owner ].! !

PRStructuresWidget subclass: #PRSearchWidget
	instanceVariableNames: 'searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRSearchWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'box search'! !

!PRSearchWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRSearchWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Search'! !

!PRSearchWidget methodsFor: 'rendering' stamp: 'lr 2/11/2006 16:54'!
renderInputOn: html
	html form: [
		html textInput
			id: (self ajaxId: #search);
			style: 'width: 95%';
			value: self searchText;
			callback: [ :value | self searchText: value ];
			in: [ :tag |
				self hasScriptaculous ifTrue: [
					tag onKeyPress: (html ajax
						id: (self ajaxId: #result);
						triggerCallbackFor: (self ajaxId: #search);
						on: #renderResultOn: of: self) ] ] ].! !

!PRSearchWidget methodsFor: 'rendering' stamp: 'lr 2/10/2006 20:03'!
renderResultOn: html
	self items in: [ :collection |
		collection isEmpty 
			ifTrue: [ html span with: nil ]
			ifFalse: [
				html div style: 'height: 6px'.
				self renderItems: self items on: html ] ].! !

!PRSearchWidget methodsFor: 'rendering' stamp: 'lr 2/10/2006 19:08'!
renderWidgetOn: html
	self renderInputOn: html.
	html div
		id: (self ajaxId: #result);
		with: [ self renderResultOn: html ].! !

!PRSearchWidget methodsFor: 'accessing-properties' stamp: 'lr 2/10/2006 19:07'!
searchText
	^ searchText ifNil: [ searchText := String new ].! !

!PRSearchWidget methodsFor: 'accessing-properties' stamp: 'lr 2/10/2006 19:08'!
searchText: aString
	searchText := aString! !

!PRSearchWidget methodsFor: 'accessing' stamp: 'lr 2/10/2006 19:15'!
unfilteredItems
	^ PRFullTextSearch from: self context root find: self searchText caseSensitive: false.! !

!PRStructuresWidget class methodsFor: 'accessing-defaults' stamp: 'lr 10/29/2005 22:32'!
defaultFilter
	^ Array new.! !

!PRStructuresWidget class methodsFor: 'accessing-defaults' stamp: 'lr 9/5/2005 19:59'!
defaultShowIcons
	^ true! !

!PRStructuresWidget class methodsFor: 'accessing-description' stamp: 'lr 12/16/2005 12:03'!
descriptionFilter
	^ (MAMultipleOptionDescription selector: #filter label: 'Filter' priority: 210 default: self defaultFilter)
		options: (MADynamicObject on: [ PRStructure withAllConcreteClasses ]);
		componentClass: MACheckboxGroupComponent;
		reference: MAClassDescription new;
		beSorted;
		yourself.! !

!PRStructuresWidget class methodsFor: 'accessing-description' stamp: 'lr 9/5/2005 19:59'!
descriptionShowIcons
	^ MABooleanDescription selector: #showIcons label: 'Show Icons' priority: 200 default: self defaultShowIcons.! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 10/31/2005 18:03'!
filter
	^ filter ifNil: [ filter := self class defaultFilter ].! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 10/29/2005 22:32'!
filter: aCollection
	filter := aCollection! !

!PRStructuresWidget methodsFor: 'testing' stamp: 'lr 10/29/2005 22:39'!
isFiltered: aStructure
	^ self filter anySatisfy: [ :each | aStructure isKindOf: each ].! !

!PRStructuresWidget methodsFor: 'accessing' stamp: 'lr 12/16/2005 12:22'!
items
	^ self unfilteredItems reject: [ :each | self isFiltered: each ].! !

!PRStructuresWidget methodsFor: 'rendering' stamp: 'lr 2/13/2006 15:39'!
renderItem: aStructure on: html
	self showIcons ifTrue: [
		html image
			url: (html context 
				urlForDocument: aStructure icon 
				mimeType: 'image/png');
			altText: aStructure class label ].
	html anchor
		class: (self selected = aStructure 
			ifTrue: [ 'active' ]);
		goto: (self context structure: aStructure);
		text: aStructure title.! !

!PRStructuresWidget methodsFor: 'accessing' stamp: 'lr 9/30/2005 19:41'!
selected
	^ self context structure.! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 9/5/2005 20:00'!
showIcons
	^ self propertyAt: #showIcons ifAbsent: [ self class defaultShowIcons ].! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 9/5/2005 20:00'!
showIcons: aBoolean
	self propertyAt: #showIcons put: aBoolean.! !

!PRStructuresWidget methodsFor: 'accessing' stamp: 'lr 12/21/2005 09:42'!
unfilteredItems
	^ self subclassResponsibility.! !

PRStructuresWidget subclass: #PRTreeWidget
	instanceVariableNames: 'expanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRTreeWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultAutoCollapse
	^ true! !

!PRTreeWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultAutoExpand
	^ true! !

!PRTreeWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultCssClass
	^ 'box tree'! !

!PRTreeWidget class methodsFor: 'accessing-description' stamp: 'lr 10/21/2005 17:34'!
descriptionAutoCollapse
	^ MABooleanDescription selector: #autoCollapse label: 'Auto Collapse' priority: 310 default: self defaultAutoCollapse.! !

!PRTreeWidget class methodsFor: 'accessing-description' stamp: 'lr 10/21/2005 17:34'!
descriptionAutoExpand
	^ MABooleanDescription selector: #autoExpand label: 'Auto Expand' priority: 300 default: self defaultAutoExpand.! !

!PRTreeWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false! !

!PRTreeWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Tree'! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoCollapse
	^ self propertyAt: #autoCollapse ifAbsent: [ self class defaultAutoCollapse ].! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoCollapse: aBoolean
	self propertyAt: #autoCollapse put: aBoolean.! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoExpand
	^ self propertyAt: #autoExpand ifAbsent: [ self class defaultAutoExpand ].! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoExpand: aBoolean
	self propertyAt: #autoExpand put: aBoolean.! !

!PRTreeWidget methodsFor: 'private' stamp: 'lr 1/14/2006 17:12'!
childrenOf: aStructure
	^ aStructure enumerator contents
		reject: [ :each | self isFiltered: each ].! !

!PRTreeWidget methodsFor: 'actions' stamp: 'lr 12/16/2005 12:05'!
collapseStructure: aStructure
	expanded remove: aStructure ifAbsent: [ "should never happen" ].! !

!PRTreeWidget methodsFor: 'actions' stamp: 'lr 10/21/2005 17:43'!
expandStructure: aStructure
	expanded add: aStructure.! !

!PRTreeWidget methodsFor: 'initialization' stamp: 'lr 10/21/2005 16:45'!
initialize
	super initialize.
	self session registerObjectForBacktracking: (expanded := Set new).! !

!PRTreeWidget methodsFor: 'testing' stamp: 'lr 10/21/2005 16:49'!
isExpanded: aNode
	^ expanded includes: aNode.! !

!PRTreeWidget methodsFor: 'events' stamp: 'lr 10/21/2005 17:47'!
onChangeContext: aContext
	super onChangeContext: aContext.
	self autoCollapse
		ifTrue: [ expanded removeAll: expanded copy ]. 
	self autoExpand
		ifTrue: [ expanded addAll: aContext structure parents ].! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/29/2005 22:41'!
renderStructureButton: aStructure on: html
	| isExpanded |
	html span 
		class: 'button';
		with: [
			(self childrenOf: aStructure) notEmpty ifTrue: [
				isExpanded := self isExpanded: aStructure.
				html anchor
					callback: [ 
						isExpanded 
							ifTrue: [ self collapseStructure: aStructure ]
							ifFalse: [ self expandStructure: aStructure ] ];
					with: (isExpanded
						ifTrue: [ '-' ]
						ifFalse: [ '+' ]) ] ].! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/29/2005 22:42'!
renderStructureChildren: aStructure on: html
	| children |
	(self isExpanded: aStructure)
		ifFalse: [ ^ self ].
	children := self childrenOf: aStructure.
	children isEmpty ifTrue: [ ^ self ].
	html unorderedList: [
		children do: [ :each |
			self renderStructure: each on: html ] ].! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/21/2005 16:51'!
renderStructureLabel: aStructure on: html
	self renderItem: aStructure on: html.! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/21/2005 17:45'!
renderStructure: aStructure on: html
	html listItem: [
		self renderStructureButton: aStructure on: html.
		self renderStructureLabel: aStructure on: html.
		self renderStructureChildren: aStructure on: html ].! !

!PRTreeWidget methodsFor: 'rendering' stamp: 'lr 10/21/2005 17:21'!
renderWidgetOn: html
	html unorderedList: [ self renderStructure: self context root on: html ].! !

!PRTreeWidget methodsFor: 'accessing' stamp: 'lr 12/16/2005 12:23'!
unfilteredItems
	self shouldNotImplement! !

PRListWidget subclass: #PRViewsWidget
	instanceVariableNames: 'viewClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRViewsWidget class methodsFor: 'accessing-default' stamp: 'lr 10/21/2005 15:36'!
defaultCssClass
	^ 'box views'! !

!PRViewsWidget class methodsFor: 'accessing-default' stamp: 'lr 1/23/2006 09:28'!
defaultViewClasses
	^ (Array withAll: PRViewComponent withAllConcreteClasses)
		sort: [ :a :b | a label caseInsensitiveLessOrEqual: b label ];
		yourself.! !

!PRViewsWidget class methodsFor: 'accessing-description' stamp: 'lr 1/23/2006 09:38'!
descriptionCommandClasses
	^ (MAMultipleOptionDescription selector: #viewClasses label: 'View Classes' priority: 200)
		options: (MADynamicObject on: [ self defaultViewClasses ]);
		componentClass: MAListCompositonComponent;
		reference: MAClassDescription new;
		beOrdered;
		yourself.! !

!PRViewsWidget class methodsFor: 'testing' stamp: 'lr 10/21/2005 15:34'!
isAbstract
	^ false! !

!PRViewsWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Views'! !

!PRViewsWidget methodsFor: 'accessing' stamp: 'lr 2/5/2006 10:17'!
items
	| view |
	^ Array streamContents: [ :stream |
		self context views in: [ :views |
			self viewClasses do: [ :class |
				view := views
					detect: [ :each | each = class ]
					ifNone: [ nil ].
				view isNil 
					ifFalse: [ stream nextPut: view ] ] ] ].! !

!PRViewsWidget methodsFor: 'rendering' stamp: 'lr 11/17/2005 15:37'!
renderItem: aClass on: html
	html anchor
		goto: (self context 
			command: (PRViewCommand new
				viewComponentClass: aClass;
				yourself));
		with: aClass label.! !

!PRViewsWidget methodsFor: 'accessing' stamp: 'lr 10/21/2005 14:37'!
selected
	^ self context command isView
		ifTrue: [ self context command viewComponent class ].! !

!PRViewsWidget methodsFor: 'accessing-settings' stamp: 'lr 1/23/2006 09:30'!
viewClasses
	^ viewClasses ifNil: [ viewClasses := self class defaultViewClasses ].! !

!PRViewsWidget methodsFor: 'accessing-settings' stamp: 'lr 1/23/2006 09:31'!
viewClasses: aCollection
	viewClasses := aCollection! !

PRBoxWidget subclass: #PRTocWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRTocWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultCssClass
	^ 'box toc'! !

!PRTocWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false! !

!PRTocWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Table of Contents'! !

!PRTocWidget methodsFor: 'rendering' stamp: 'lr 11/17/2005 16:19'!
renderWidgetOn: html
	PRTocRenderer new
		start: self context structure document
		in: self on: html.! !

!PRWidget methodsFor: 'private' stamp: 'lr 12/5/2005 22:08'!
expand: aString
	^ PRMacroExpander default value: aString value: self context.! !

!PRWidget methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^ properties.! !

!PRWidget methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey
	^ self properties at: aKey.! !

!PRWidget methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey ifAbsentPut: aBlock
	^ self properties at: aKey ifAbsentPut: aBlock.! !

!PRWidget methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey ifAbsent: aBlock
	^ self properties at: aKey ifAbsent: aBlock.! !

!PRWidget methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey put: aValue
	^ self properties at: aKey put: aValue.! !

!PRWidget methodsFor: 'rendering' stamp: 'lr 2/19/2006 14:49'!
renderContentOn: html
	self renderWidgetOn: html.! !

!PRWidget methodsFor: 'rendering' stamp: 'lr 5/9/2005 10:04'!
renderWidgetOn: html
	self subclassResponsibility.! !

PRWidget subclass: #PRXHtmlWidget
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRXHtmlWidget class methodsFor: 'accessing-defaults' stamp: 'lr 2/19/2006 14:57'!
defaultText
	^ '<h1>%k</h1><h2>%c</h2>'! !

!PRXHtmlWidget class methodsFor: 'accessing-descriptions' stamp: 'lr 2/19/2006 14:55'!
descriptionCommandClasses
	^ MAMemoDescription selector: #text label: 'Text' priority: 100 default: self defaultText.! !

!PRXHtmlWidget class methodsFor: 'testing' stamp: 'lr 2/19/2006 14:42'!
isAbstract
	^ false! !

!PRXHtmlWidget class methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:42'!
label
	^ 'XHtml'! !

!PRXHtmlWidget methodsFor: 'rendering' stamp: 'lr 2/19/2006 14:58'!
renderWidgetOn: html
	html html: (self expand: self text).! !

!PRXHtmlWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:55'!
text
	^ text ifNil: [ text := self class defaultText ].! !

!PRXHtmlWidget methodsFor: 'accessing' stamp: 'lr 2/19/2006 14:37'!
text: aString
	text := aString! !

PRVisitor subclass: #PRRenderer
	instanceVariableNames: 'component html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

PRRenderer subclass: #PRDeepRenderer
	instanceVariableNames: 'visited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

!PRDeepRenderer methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
doesRemember: anObject
	visited size to: 1 by: -1 do: [ :index |
		(visited at: index) = anObject
			ifTrue: [ ^ true ] ].
	^ false.! !

!PRDeepRenderer methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
remember: anObject while: aBlock
	visited addLast: anObject.
	aBlock ensure: [ visited removeLast ].! !

!PRDeepRenderer methodsFor: 'visiting' stamp: 'lr 11/22/2005 23:26'!
start: anObject
	visited := OrderedCollection new.
	super start: anObject.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLinkBroken: anObject
	self visitLink: anObject.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLinkEmbed: anObject
	self visit: anObject target.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLinkGoto: anObject
	self visitLink: anObject.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLink: anObject
	anObject isBroken
		ifTrue: [ self visitInternalLinkBroken: anObject ]
		ifFalse: [ 
			anObject isEmbedded
				ifFalse: [ self visitInternalLinkGoto: anObject ]
				ifTrue: [ 
					(self doesRemember: anObject target)
						ifTrue: [ self visitInternalLinkGoto: anObject ]
						ifFalse: [ 
							self
								remember: anObject target
								while: [ self visitInternalLinkEmbed: anObject ] ] ] ].! !

!PRDeepRenderer methodsFor: 'visiting-structure' stamp: 'lr 4/17/2005 11:58'!
visitStructure: anObject
	self visit: anObject document.! !

PRDeepRenderer subclass: #PRTocRenderer
	instanceVariableNames: 'enabled current counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

!PRTocRenderer methodsFor: 'utilities' stamp: 'lr 4/17/2005 11:59'!
enable: aBoolean while: aBlock
	| old |
	old := enabled. enabled := aBoolean.
	aBlock ensure: [ enabled := old ].! !

!PRTocRenderer methodsFor: 'utilities' stamp: 'lr 4/17/2005 11:59'!
ifEnabledDo: aBlock 
	enabled ifTrue: [ aBlock value ].! !

!PRTocRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
level: anInteger
	| value |
	value := anInteger min: 6 max: 1.
	value < current ifTrue: [
		anInteger + 1 to: current do: [ :index |
			counter at: index put: 0 ] ].
	counter
		at: (current := value)
		put: (counter at: value) + 1.! !

!PRTocRenderer methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:59'!
start: anObject
	enabled := false. current := 1.
	counter := Array new: 6 withAll: 0.
	super start: anObject.! !

!PRTocRenderer methodsFor: 'visiting-document' stamp: 'lr 9/30/2005 20:38'!
visitHeader: anObject
	self level: anObject level.
	(counter first: current)
		do: [ :each | html render: each; text: '.' ].
	html space.
	html anchor
		url: '#' , anObject hash asString;
		with: [
			self 
				enable: true 
				while: [ super visitHeader: anObject ] ].
	html break.! !

!PRTocRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitText: anObject
	self ifEnabledDo: [ html text: anObject text ].! !

PRDeepRenderer subclass: #PRViewRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:16'!
visitAnchor: anObject
	html anchor name: anObject name.! !

!PRViewRenderer methodsFor: 'visiting-structure' stamp: 'lr 11/22/2005 23:28'!
visitComponent: anObject
	html render: (self context componentAt: anObject).! !

!PRViewRenderer methodsFor: 'visiting-links' stamp: 'lr 1/3/2006 09:14'!
visitExternalLink: anObject
	html anchor
		class: 'external';
		url: anObject url;
		with: [ self visitLink: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-structure' stamp: 'lr 11/21/2005 20:58'!
visitFile: anObject
	| url |
	anObject isText
		ifTrue: [ html preformatted: anObject contents ]
		ifFalse: [
			url := html context 
				urlForDocument: anObject contents
				mimeType: anObject mimetype
				fileName: anObject filename.
			anObject file isImage
				ifTrue: [ html image url: url; altText: anObject title ]
				ifFalse: [ 
					anObject file isAudio | anObject file isVideo
						ifTrue: [ (html tag: 'embed') attributeAt: 'url' put: url; with: anObject title ]
						ifFalse: [ html anchor url: url; with: anObject title ] ] ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 2/13/2006 17:40'!
visitHeader: anObject
	html heading
		level: (6 min: anObject level + 1);
		with: [ 
			html anchor name: anObject hash.
			super visitHeader: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitHorizontalRule: anObject
	html horizontalRule.! !

!PRViewRenderer methodsFor: 'visiting-links' stamp: 'lr 2/13/2006 15:44'!
visitInternalLinkBroken: anObject
	| lookup context |
	lookup := PRIncompletePathLookup 
		start: self context structure
		path: anObject reference.
	context := self context 
		structure: lookup key 
		command: PRAddCommand new.
	context command name: lookup value.
	html anchor
		class: 'broken';
		goto: context;
		with: [ self visitLink: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-links' stamp: 'lr 12/20/2005 23:32'!
visitInternalLinkGoto: anObject
	html anchor
		class: 'internal';
		goto: (self context structure: anObject target);
		with: [ self visitLink: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitLink: anObject
	anObject hasChildren
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ html render: anObject reference ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitListItem: anObject
	html listItem with: [ super visitListItem: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:19'!
visitOrderedList: anObject
	html orderedList with: [ super visitOrderedList: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-structure' stamp: 'lr 4/17/2005 11:59'!
visitPage: anObject
	self 
		remember: anObject
		while: [ super visitPage: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:16'!
visitParagraph: anObject
	html paragraph with: [ super visitParagraph: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitPreformatted: anObject
	html preformatted: [ 
		self
			visitAll: anObject children
			separatedBy: [ html text: Character cr ] ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitSmiley: anObject
	html image
		url: (html context 
			urlForDocument: (anObject class 
				smileyAt: anObject text 
				ifAbsent: [ ^ super visitSmiley: anObject ])
			mimeType: 'image/gif');
		altText: anObject text.! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 10/29/2005 22:17'!
visitTableCell: anObject
	html tableData
		style: (String streamContents: [ :stream |
			anObject align isNil ifFalse: [ 
				stream 
					nextPutAll: 'text-align: '; 
					nextPutAll: anObject align ] ]);
		with: [ super visitTableCell: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitTableRow: anObject
	html tableRow with: [ super visitTableRow: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitTable: anObject
	html table with: [ super visitTable: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitText: anObject
	html html: anObject text.! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitUnorderedList: anObject
	html unorderedList with: [ super visitUnorderedList: anObject ].! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
component
	^ component! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
component: aComponent
	component := aComponent! !

!PRRenderer methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:05'!
context
	^ PRCurrentContext value.! !

!PRRenderer methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:05'!
context: aContext
	PRCurrentContext value: aContext.! !

!PRRenderer methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:58'!
continue: anObject in: aComponent on: aRenderer
	| oldComponent oldRenderer |
	oldComponent := self component. 
	oldRenderer := self renderer.
	self component: aComponent.
	self renderer: aRenderer.
	[ self visit: anObject ] ensure: [ 
		self component: oldComponent.
		self renderer: oldRenderer ].! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
renderer
	^ html! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
renderer: aRenderer
	html := aRenderer! !

!PRRenderer methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:58'!
start: anObject in: aComponent on: aRenderer
	self component: aComponent.
	self renderer: aRenderer.
	self start: anObject.! !

!PRVisitor methodsFor: '*pier-seaside-visiting-structure' stamp: 'lr 10/21/2005 11:36'!
visitComponent: anObject
	self visitStructure: anObject.! !

!PRContext methodsFor: '*pier-seaside-private' stamp: 'lr 10/26/2005 00:08'!
buildComponentFor: aStructure
	^ aStructure component
		onChangeContext: self;
		yourself.! !

!PRContext methodsFor: '*pier-seaside-caching' stamp: 'lr 10/26/2005 00:07'!
componentAt: aStructure
	"Return the cached component of aStructure, if none is existing yet create a new one."

	^ self componentDictionary at: aStructure ifAbsentPut: [ self buildComponentFor: aStructure ].! !

!PRContext methodsFor: '*pier-seaside-private' stamp: 'lr 10/25/2005 23:38'!
componentDictionary
	^ self propertyAt: #components ifAbsentPut: [ Dictionary new ].! !

!PRContext methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/24/2005 09:04'!
components
	^ self componentDictionary values.! !

!PRContext methodsFor: '*pier-seaside-caching' stamp: 'lr 10/24/2005 09:06'!
removeComponentAt: aStructure
	"Remove any cached component for aStructure."

	^ self componentDictionary removeKey: aStructure ifAbsent: [ ].! !

!PRContext methodsFor: '*pier-seaside-accessing' stamp: 'lr 1/4/2006 22:11'!
renderer
	^ self propertyAt: #renderer ifAbsentPut: [ PRViewRenderer new ].! !

!PRContext methodsFor: '*pier-seaside-accessing' stamp: 'lr 1/4/2006 22:21'!
session
	"Answer the cached seaside session, this is a short-cut to avoid to unnecessary lookups."

	^ self propertyAt: #session ifAbsentPut: [ WACurrentSession value ].! !

!PRContext methodsFor: '*pier-seaside-accessing' stamp: 'lr 2/5/2006 10:17'!
views
	"Answer a list of possible views, dispatching trough the command class."

	^ PRViewComponent withAllConcreteClasses
		select: [ :each | each isValidIn: self ].! !

!WAAnchorTag methodsFor: '*pier-seaside-linking' stamp: 'lr 2/19/2006 17:58'!
goto: aContext
	"Initialize the receiver to properly activate aContext when being clicked. This includes a callback and a human-readable and bookmarkable url."

	| actionUrl |
	aContext isValid
		ifFalse: [ ^ self class: 'protected'; url: '#' ].
	actionUrl := canvas context actionUrl withParameter: (canvas callbacks 
		registerActionCallback: [ PRCurrentContext value: aContext ]).
	self url: (actionUrl adaptToContext: aContext) displayString.! !

WADynamicVariable subclass: #PRRecursionBlocker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRRecursionBlocker class methodsFor: 'accessing' stamp: 'lr 1/27/2006 10:11'!
do: aBlock else: aRecursionBlock
	^ self value isNil
		ifFalse: [ aRecursionBlock value ]
		ifTrue: [ self use: self during: aBlock ]. ! !

WAStringLibrary subclass: #PRPierLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRPierLibrary methodsFor: 'accessing' stamp: 'lr 1/9/2006 11:53'!
cssKeys
	^ self selectorsForCategory: 'css'.! !

!PRPierLibrary methodsFor: 'accessing' stamp: 'lr 1/9/2006 11:57'!
jsKeys
	^ self selectorsForCategory: 'js'.! !

!PRPierLibrary methodsFor: 'private' stamp: 'lr 1/9/2006 11:57'!
selectorsForCategory: aString
	^ Array streamContents: [ :stream |
		self class organization categories do: [ :each |
			(each endsWith: aString) ifTrue: [ 
				stream nextPutAll: (self class organization
					listAtCategoryNamed: each) ] ] ].! !

WARenderLoopMain subclass: #PRPierMain
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRPierMain methodsFor: 'private' stamp: 'lr 1/5/2006 09:13'!
classFromRequest: aRequest name: aString base: aBaseClass
	| class |
	(class := PRCompatibility classNamed: (aRequest 
		at: aString ifAbsent: [ ^ nil ])) isNil 
			ifTrue: [ ^ nil ].
	(class inheritsFrom: aBaseClass) 
		ifFalse: [ ^ nil ].
	^ class.! !

!PRPierMain methodsFor: 'private' stamp: 'lr 1/5/2006 09:49'!
commandFrom: aRequest
	| commandClass command viewClass |
	commandClass := self classFromRequest: aRequest name: 'command' base: PRCommand.
	(commandClass isNil or: [ commandClass isAbstract ])
		ifTrue: [ commandClass := context structure viewCommandClass ].
	(command := commandClass new) isView 
		ifFalse: [ ^ command ].
	viewClass := self classFromRequest: aRequest name: 'view' base: PRViewComponent.
	viewClass isNil 
		ifFalse: [ command viewComponentClass: viewClass ].
	^ command.! !

!PRPierMain methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
context
	^ context! !

!PRPierMain methodsFor: 'accessing' stamp: 'lr 1/5/2006 10:19'!
createRoot
	^ self rootClass on: self context.! !

!PRPierMain methodsFor: 'initialize-release' stamp: 'lr 1/5/2006 09:30'!
initializeWith: aRequest
	context := PRContext kernel: self kernel.
	context setStructure: (self structureFrom: aRequest).
	context setCommand: (self commandFrom: aRequest).! !

!PRPierMain methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
kernel
	^ self application preferenceAt: #kernel.! !

!PRPierMain methodsFor: 'processing' stamp: 'lr 1/5/2006 10:16'!
start: aRequest
	self initializeWith: aRequest.
	super start: aRequest.! !

!PRPierMain methodsFor: 'private' stamp: 'lr 2/19/2006 19:03'!
structureFrom: aRequest
	| path |
	path := (aRequest url beginsWith: self application basePath)
		ifTrue: [ aRequest url allButFirst: self application basePath size ]
		ifFalse: [ aRequest url ].
	(path beginsWith: 'seaside/pier/')
		ifTrue: [ path := aRequest url allButFirst: 'seaside/pier/' size ].
	^ PRPathLookup 
		start: self kernel root path: path 
		onError: [ self kernel root ].! !

MATextInputComponent subclass: #PRStructureComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Magritte'!

!PRStructureComponent methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:09'!
string: aString
	self value: (PRPathLookup
		start: self context structure path: aString
		onError: [ aString ]).! !

!PRStructureDescription class methodsFor: '*pier-seaside-defaults' stamp: 'lr 11/17/2005 16:09'!
defaultComponentClasses
	^ Array with: PRStructureComponent.! !
PRPierFrame initialize!
